import { DATASET_STATES } from '@/config'
import { UUID, ElementList } from '@/types'

export type DatasetState = keyof typeof DATASET_STATES

export interface Dataset {
  id: UUID
  state: DatasetState
  name: string
  description: string
  sets: string[]
  set_elements: Record<string, number> | null
  corpus_id: UUID
  creator: string
  task_id: UUID | null
  created: string
  updated: string
}

export interface DatasetElementList {
  set: string
  element: ElementList
}

export interface ElementDataset {
  dataset: Dataset
  set: string
  previous?: UUID | null
  next?: UUID | null
}

export interface ProcessDataset {
  id: UUID,
  dataset: Dataset,
  sets: string[]
}
