import {
  CorpusLight,
  UUID,
  WorkerRunSummary
} from '@/types'

export interface EntityMetas {
  [property_name: string]: string
}

export interface EntityType {
  id: UUID,
  name: string,
  color: string
}

export interface EntityRole {
  id: UUID
  parent_name: string
  child_name: string
  parent_type_id: UUID
  child_type_id: UUID
}

export interface EntityLight {
  id: UUID
  name: string
  type: EntityType
  metas: EntityMetas | null
  validated: boolean
  worker_version_id: UUID | null
  worker_run: WorkerRunSummary | null
}

export interface EntityLink {
  id: UUID
  parent: EntityLight
  child: EntityLight
  role: EntityRole
}

export interface Entity extends EntityLight {
  corpus: CorpusLight
  children: EntityLink[]
  parents: EntityLink[]
}

export interface TranscriptionEntity {
  offset: number
  length: number
  entity: EntityLight
  worker_run: WorkerRunSummary | null
  worker_version_id: UUID | null
  confidence: number
}